# -*- coding: utf-8 -*-

import sys, os, time
import json
import glob
import time
import MySQLdb
import shutil
import zipfile
from operator import itemgetter
import logging, logging.config

logging.config.fileConfig('maint_log.ini')

logger = logging.getLogger('su.artix.shiftdeleting')

if __name__ == '__main__':

    queries = [
          "DELETE b FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN goodsitem g ON doc.documentid = g.documentid LEFT JOIN discitem di ON g.goodsitemid = di.goodsitemid LEFT JOIN button b ON di.buttonid = b.buttonid WHERE w.shiftnum = %(shift)s ",
          "DELETE c FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN client c ON doc.clientitemid = c.clientitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE c FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN carditem ci ON doc.documentid = ci.documentid LEFT JOIN client c ON ci.clientitemid = c.clientitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE g, b, d, c, p FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN goodsitem g ON doc.documentid = g.documentid LEFT JOIN button b ON g.buttonid = b.buttonid LEFT JOIN department d ON g.departmentid = d.departmentid LEFT JOIN `client` c ON d.clientitemid = c.clientitemid LEFT JOIN paymentitem p ON g.paymentitemid = p.paymentitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE g, b, d, c, p FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN stornogoodsitem g ON doc.documentid = g.documentid LEFT JOIN button b ON g.buttonid = b.buttonid LEFT JOIN department d ON g.departmentid = d.departmentid LEFT JOIN `client` c ON d.clientitemid = c.clientitemid LEFT JOIN paymentitem p ON g.paymentitemid = p.paymentitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE b, dp, c FROM document d LEFT JOIN workshift w ON w.workshiftid = d.workshiftid LEFT JOIN button b ON d.buttonid = b.buttonid LEFT JOIN department dp ON d.departmentid = dp.departmentid LEFT JOIN `client` c ON dp.clientitemid = c.clientitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE c FROM crights c join (select workshiftid FROM workshift WHERE workshift.shiftnum = %(shift)s ) w ON c.workshiftid = w.workshiftid",
          "DELETE FROM workshift WHERE workshift.shiftnum = %(shift)s "
      ]
    logger.info("Service starts")
    data_file = open('/linuxcash/cash/conf/maint.json')
    data = json.load(data_file)
    with open('/linuxcash/cash/data/cash.reg', 'rb') as infile:
        registry = json.load(infile)
    shiftCount = data["manual"]["shiftCount"] if data.has_key("manual") else 180
    timeout = data["manual"]["timeout"] if data.has_key("manual") else 240
    outputDir = data["manual"]["outputDir"] if data.has_key("manual") else "/linuxcash/logs/backup/"
    if not os.path.exists(os.path.dirname(outputDir)):
            os.makedirs(os.path.dirname(outputDir))
    cashCode = registry["cashCode"]
    
    conn = MySQLdb.connect(host='localhost', user='root', passwd='', db="documents")
    cur = conn.cursor()
    cur.execute('set names utf8')
    cur.execute("SELECT cashcode FROM workshift GROUP BY cashcode")
    cashList = cur.fetchall()
    for cash in cashList:
        logger.info("Work with cash #%s" % cash)
        query = "SELECT shiftnum FROM workshift where cashcode = %s ORDER BY shiftnum DESC LIMIT %s,1000000 " 
        params = [(str(cash[0]),shiftCount)]
        cur.executemany(query,params)
        shiftList = cur.fetchall() 
        if not shiftList:
            logger.info("Shifts is not found for cash # %s" %cash)
        for shift in shiftList:
            shift = shift[0]
            if cash[0] == cashCode:
                output = outputDir + "%s_%s.res" % (cashCode,shift)
                logger.info("Unload shift #%s to %s" % (shift, output))
                os.system("/linuxcash/cash/exchangesystems/nes/unload.sh -o %s -s %s@%s -c %s" % (output,shift,shift,cashCode))
            logger.info('Delete shift #%s ' % shift)
            for queryStr in queries:
                query = queryStr % vars()
                cur.execute(query)
                conn.commit()
            time.sleep(timeout)
    cur.close()
    conn.close()
    logger.info("Service stopped")
    